RFRMT-SEXPR 1.0 BASE64

(table "rformat-version-major"
       1
       "rformat-version-minor"
       0
       "subformat"
       (table "identifier" 	"reng_resource"
              "name" 	"REng resource"
              "description" 	"REng engine asset")
       "root-node"
       (array (array "result"
                     "inline"
                     (array "shader"
                            "fragment"
                            "#version 330 core

layout(std140) uniform lightData
{
	vec3 direction;
	vec3 color;
	vec3 camPos;
};

uniform sampler2D baseColorTex;
uniform sampler2D normalTex;
uniform sampler2D positionTex;

in vec2 uv;

out vec3 FragColor;

void main()
{   
    vec3  baseColor  = texture2D(baseColorTex, uv).rgb;
	vec3  worldPos   = texture2D(positionTex, uv).rgb;   
	vec3  N          = normalize(texture2D(normalTex, uv).rgb);
	  	   	
	//ambient
	float ambientStrength = 0.1;
    vec3 ambient = ambientStrength * color;
    ambient = ambient * baseColor;
	
	//diffuse
	float diff = max(dot(N, direction), 0.0);
	vec3 diffuse = diff * color * baseColor;
    
    FragColor = ambient + diffuse;  
}  
"))))
