RFRMT-SEXPR 1.0 BASE64

(table "rformat-version-major"
       1
       "rformat-version-minor"
       0
       "subformat"
       (table "identifier" 	"reng_resource"
              "name" 	"REng resource"
              "description" 	"REng engine asset")
       "root-node"
       (array (array "result"
                     "inline"
                     (array "shader"
                            "fragment"
                            "#version 330 core

precision highp float;

layout(std140) uniform projData
{
  mat4 worldTransMat;
  mat4 camTransMat;
  mat3 normalMat;
  vec3 camPos;
};


uniform sampler2D baseColorTex;
uniform sampler2D metalTex;
uniform sampler2D roughTex;
uniform sampler2D normalTex;
uniform sampler2D aoTex;

uniform sampler2D envTex;

varying vec3 worldPos;
varying vec3 rawNormal;
varying vec3 rawTangent;
varying vec3 rawBitangent;
varying vec2 uv;

layout(location=0) out vec3  baseColorOut;
layout(location=1) out float metalOut;
layout(location=2) out float roughOut;
layout(location=3) out vec3  normalOut;
layout(location=4) out vec3  ambLightOut;
layout(location=5) out vec3  lightOut;
layout(location=6) out vec3  positionOut;

void main ()
{
  vec3  baseColor    = texture2D(baseColorTex,  uv).rgb;
  float metal        = texture2D(metalTex,  uv).x;
  float rough        = texture2D(roughTex,  uv).x;
  vec3  normalOffset = texture2D(normalTex,  uv).xyz*2 - 1;
  float ao           = texture2D(aoTex,  uv).x;
  
  vec3  meshNormal   = normalize(rawNormal);
  vec3  tangent      = normalize(rawTangent);
  vec3  bitangent    = normalize(rawBitangent);

  vec3 normal =                                 \\
    normalOffset.x * tangent +                  \\
    normalOffset.y * bitangent +                \\
    normalOffset.z * meshNormal;

  baseColor = pow(baseColor, vec3(2.2));
  //metal = pow(metal, 2.2);
  //rough = pow(rough, 2.2);
  
  // highlight visible backfaces
  baseColor = gl_FrontFacing ? baseColor : vec3(1, 0, 1);

  baseColorOut = baseColor;
  metalOut = metal;
  roughOut = rough;
  normalOut = normal;
  ambLightOut = vec3(0);
  lightOut = vec3(0);
  positionOut = worldPos;
}


"))))
