RFRMT-SEXPR 1.0 BASE64

(table "rformat-version-major"
       1
       "rformat-version-minor"
       0
       "subformat"
       (table "identifier" 	"reng_resource"
              "name" 	"REng resource"
              "description" 	"REng engine asset")
       "root-node"
       (array (array "result"
                     "inline"
                     (array "shader"
                            "fragment"
                            "#version 330 core

layout(std140) uniform lightData
{
	vec3 position;
	vec3 color;
	vec3 camPos;
};

uniform sampler2D baseColorTex;
uniform sampler2D normalTex;
uniform sampler2D positionTex;

in vec2 uv;

out vec3 FragColor;

void main()
{   
	float constant = 1.0f;
    float linear = 0.7f;
    float quadratic = 1.8f;
    
	vec3  baseColor  = texture2D(baseColorTex, uv).rgb;
	vec3  worldPos   = texture2D(positionTex, uv).rgb;
	vec3  N          = normalize(texture2D(normalTex, uv).rgb);
	
	//diffuse
	vec3 dir = normalize(position - worldPos);
	float diff = max(dot(N, dir), 0.0);
	vec3 diffuse = diff * color * baseColor;
	
	float distance    = length(position - worldPos);
	float attenuation = 1.0 / (constant + linear * distance + quadratic * (distance * distance));    
	
	diffuse  *= attenuation;
	
    FragColor = diffuse;
}  "))))
