#version 140

precision highp float;

layout(std140) uniform shaderData
{
  mat4  transform;
  float time;
  float aspect;
};

varying vec2 uv;

void main ()
{
  const vec4 c1 = vec4(0.0, 0.2, 0.4, 1.0);
  const vec4 c2 = vec4(0.0, 0.6, 0.8, 1.0);

  float v = length(fwidth(uv)) * .7;
    
  float f = fract(uv.x*2*aspect - uv.y*.2 - time);
  
  f = smoothstep(.25-v, .25+v, f) - smoothstep(.75-v, .75+v, f);
  
  gl_FragColor = mix(c1, c2, f);
}

