#version 140

precision highp float;

layout(std140) uniform shaderData
{
  mat4  transform;
  float rotation;
  float progress;
};

uniform sampler2D fontTex;

varying vec2 cart;

const float PI = 3.1415926535897932;
const float TAU = 2*PI;

float hash (vec2 co)
{
  return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void main ()
{
  float a = atan(cart.y, cart.x) + PI;
  float r = length(cart);
  float va = length(fwidth(a)) * 0.1;  // TODO wrong
  float vr = length(fwidth(r)) * 1.0;  // TODO wrong

  // === activity ===
  //float afrac = 1 - fract(a+rotation);
  float afrac = 1 - fract(a/TAU + rotation);

  // repetition
  //frac = fract(frac * (2+sin(time/20)));
  afrac = fract(afrac * 2);

  // falloff
  //afrac = max(0,afrac-.3) / .7;
  //afrac = smoothstep(.4, 1, afrac);
  //afrac = exp(-9*(1-afrac));
  afrac = pow(afrac,8);

  // === progress ===
  float pfrac = 1 - fract(a/TAU + .25);

  // antialiasing the start & end is surprisingly hard - watch out for artifacts
  pfrac = 1 - step(progress, pfrac);
  
  
  float frac = progress<0 ? afrac : pfrac;




  
  
  float ir = .42;
  float or = .5;

  // wobbly madness
  /*
  ir += sin(a*6-rotation*TAU) *.01;
  or -= sin(a*6+rotation*TAU) *.01;
  /**/
  
  float circ = smoothstep(ir-vr,ir,r) - smoothstep(or-vr,or,r);
  float al = frac * circ;


  // add noise to hide color banding
  float noisefac = .0005;
  al += (circ*hash(cart)*noisefac - noisefac) / (1-noisefac);

  // gamma
  al = pow(al,1/2.2);

  gl_FragColor = vec4(1,1,1, al);
}

