#version 140


layout(std140) uniform shaderData
{
  mat4  transform;

  float shear;

  // borders
  float b1;
  float b2;
  float b3;

  // colors
  vec4 c1;
  vec4 c2_1;
  vec4 c2_2;
  vec4 c3;
};


in vec2 rawVertPos;
in vec2 vertUV;

out vec2 uv;

void main ()
{
  uv = vertUV;
  vec2 vertPos = rawVertPos;

  // shear
  vertPos.x += vertPos.y * shear;
  
  vec4 posTransformed = transform * vec4(vertPos,1,1);
  gl_Position = posTransformed;
}


